/******************************************************************************
*******************************************************************************
***                                                                         ***
***                           CLONE-SIM-1.0                                 ***
***                                                                         ***
***         Copyright 1997-2000 by Georgia Institute of Technology          ***
***                          Atlanta, Georgia                               ***
***                                                                         ***
***                        All Rights Reserved                              ***


     Permission   to  use, copy   and   modify   this  software  and  its 
     documentation for any research purpose and without  fee  is   hereby
     granted, provided that the above copyright  notice  appears  in  all
     copies  and  that  both  that  copyright  notice and this permission
     notice  appear in supporting documentation.  The use or inclusion of
     this   software  or  its  documentation in any commercial product or
     distribution of  this  software to any other party without specific,
     written   prior  permission  is prohibited.

     THE SOFTWARE IS PROVIDED  AS  IS AND GEORGIA INSTITUTE OF TECHNOLOGY
     DISCLAIMS  ALL  WARRANTIES WITH  REGARD TO THIS SOFTWARE,  INCLUDING
     ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.  IN  NO EVENT
     SHALL GEORGIA INSTITUTE OF TECHNOLOGY BE  LIABLE  FOR  ANY  SPECIAL,
     INDIRECT  OR  CONSEQUENTIAL  DAMAGES   OR  ANY  DAMAGES   WHATSOEVER
     RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
     CONTRACT, NEGLIGENCE OR OTHER  TORTIOUS  ACTION,  ARISING  OUT OF OR
     IN   CONNECTION  WITH  THE  USE  OR  PERFORMANCE OF  THIS  SOFTWARE.


     ====================================================================
                                                                       
     FILE:      	cs_api.h 
     INITIAL AUTHOR:    Maria Hybinette                                      

     ====================================================================

     DESCRIPTION:
	- no dependencies on particular simulator

***.........................................................................***
*******************************************************************************
******************************************************************************/
#ifndef CS_API_H
#define CS_API_H

#include "am_arch.h"
#include "cs_internal.h"

extern int  CloneSim_Create( int UID_LP, double current_sim_time );
extern int  CloneSim_CreateOptimistic( int UID_LP, double current_sim_time );

extern int  CloneSim_Delete( int cloneID, double sTS, double eTS, CSFunc_p F );

extern int  CloneSim_GetCloneID( int UID );

/* Implemented in Interactive-Sim
extern int  CloneSim_GID( void );
extern int  CloneSim_UID( void );
*/

extern int  CloneSim_SetMsg( int source, int destination, char *Msg );
extern void CloneSim_GetMsg( int src, int dst, char *Msg,double ts,double tss);

extern void CloneSim_InitAppl( int argc, char ** argv );
extern void CloneSim_CloseAppl( void );

#endif
