/******************************************************************************
*******************************************************************************
***                                                                         ***
***                       Time Warp Version 2.5                             ***
***         Copyright 1997 by Georgia Institute of Technology               ***
***                         Atlanta, Georgia                                ***
***                                                                         ***
***                      All Rights Reserved                                ***

     Permission to use, copy and modify this software and its
     documentation  for  any research  purpose and  without fee is hereby
     granted, provided that the  above copyright  notice appears in all
     copies and  that both  that  copyright  notice  and  this permission
     notice appear in supporting  documentation.  The use or inclusion of
     this  software  or its documentation in  any  commercial  product or
     distribution of this software to any other party without specific,
     written prior permission is prohibited.

     THE SOFTWARE IS PROVIDED AS IS AND GEORGIA INSTITUTE OF TECHNOLOGY
     DISCLAIMS  ALL  WARRANTIES WITH  REGARD TO THIS SOFTWARE,  INCLUDING
     ALL IMPLIED WARRANTIES  OF  MERCHANTABILITY AND FITNESS.  IN NO EVENT
     SHALL GEORGIA INSTITUTE OF TECHNOLOGY BE LIABLE FOR ANY SPECIAL,
     INDIRECT  OR CONSEQUENTIAL DAMAGES  OR ANY DAMAGES WHATSOEVER
     RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
     CONTRACT, NEGLIGENCE OR OTHER TORTIOUS  ACTION, ARISING OUT OF  OR
     IN  CONNECTION  WITH  THE  USE  OR PERFORMANCE OF THIS SOFTWARE.

***.........................................................................***
*******************************************************************************
******************************************************************************/
#include <stdio.h>
#include "cs_count.h"

extern int print_tables[10];                                          \
counts_t my_counts[CS_MAXPE];
counter_t func_counts[CS_MAX_FUNCS];

int do_cs_count=0;

/* ---------------------------------------------------------------------------
** cs_Cntr_Initialize()
**
** DESCRIPTION: 
**
**---------------------------------------------------------------------------*/
void cs_Cntr_Initialize( int num_pe )
{
  int i,j;

  if( print_tables[4] == 0 ) return;

  for( j = 0; j < CS_MAX_FUNCS; j++ )
	{
  	for( i = 0; i < num_pe; i++)
		{
		my_counts[i].my_samples = 0;
		my_counts[i].func[j].calls = 0;
		my_counts[i].func[j].instructions = 0;
		my_counts[i].func[j].loop_1 = 0;
		my_counts[i].func[j].loop_2 = 0;
		}
	func_counts[j].calls=0;
	func_counts[j].instructions=0;
	func_counts[j].loop_1=0;
	func_counts[j].loop_2=0;
	func_counts[j].max_loop_1=0;
	func_counts[j].max_loop_2=0;
	}
}


/* ---------------------------------------------------------------------------
** cs_Cntr_ReportResultGTW()
**
** DESCRIPTION: 
**
**---------------------------------------------------------------------------*/
void cs_Cntr_ReportResultGTW( int num_pe, int TNEvent, int NetEvents )
{
  int i,j;

  int totals=0;
  int calls=0;
  int instructions=0;

  int loop_1=0;
  int loop_2=0;
  int max_loop_1=0;
  int max_loop_2=0;

  int j_loop_1_cnt =0;
  int j_loop_2_cnt =0;

  int j_loop_1_length=0;
  int j_loop_2_length=0;


extern int cs_clone_cnt;
extern int CloneSim_NumClones;
extern int clone_multiple;
extern int CloneSim_scale_size;
int	my_multiple=1;

  if( print_tables[4] == 0 ) return;

  for( i = 0; i < num_pe; i++)
	{
  	my_counts[i].my_totals = 0;
  	my_counts[i].calls = 0;
  	my_counts[i].instructions = 0;
  	my_counts[i].loop_1 = 0;
  	my_counts[i].loop_2 = 0;
  	my_counts[i].max_loop_1 = 0;
  	my_counts[i].max_loop_2 = 0;

	for( j = 0; j < CS_MAX_FUNCS; j++ )
		{
		/*
	        * if( my_counts[i].func[j].loop_1 != 0 ) 
		* 	{
		* 	j_loop_1_cnt += 
		* 	j_loop_1_length += 1;
		* 	}
	  	*/
        	func_counts[j].calls		+= my_counts[i].func[j].calls;
        	func_counts[j].instructions	+= my_counts[i].func[j].instructions;
        	func_counts[j].loop_1		+= my_counts[i].func[j].loop_1;
        	func_counts[j].loop_2		+= my_counts[i].func[j].loop_2;


		/* within processor */
		my_counts[i].my_totals +=  my_counts[i].func[j].calls;
		my_counts[i].my_totals +=  my_counts[i].func[j].instructions;
		my_counts[i].my_totals +=  my_counts[i].func[j].loop_1;
		my_counts[i].my_totals +=  my_counts[i].func[j].loop_2;

		my_counts[i].calls +=  my_counts[i].func[j].calls;
		my_counts[i].instructions +=  my_counts[i].func[j].instructions;
		my_counts[i].loop_1 +=  my_counts[i].func[j].loop_1;
		my_counts[i].loop_2 +=  my_counts[i].func[j].loop_2;

	        if( my_counts[i].max_loop_1 < my_counts[i].func[j].max_loop_1 ) 
		    my_counts[i].max_loop_1 = my_counts[i].func[j].max_loop_1;
	        if( my_counts[i].max_loop_2 < my_counts[i].func[j].max_loop_2 ) 
		    my_counts[i].max_loop_2 = my_counts[i].func[j].max_loop_2;

		/* across processors */
		totals +=  my_counts[i].func[j].calls;
		totals +=  my_counts[i].func[j].instructions;
		totals +=  my_counts[i].func[j].loop_1;
		totals +=  my_counts[i].func[j].loop_2;

		calls +=  my_counts[i].func[j].calls;
		instructions +=  my_counts[i].func[j].instructions;
		loop_1 +=  my_counts[i].func[j].loop_1;
		loop_2 +=  my_counts[i].func[j].loop_2;

	        if( max_loop_1 < my_counts[i].func[j].max_loop_1 ) 
			max_loop_1 = my_counts[i].func[j].max_loop_1;
	        if( max_loop_2 < my_counts[i].func[j].max_loop_2 ) 
			max_loop_2 = my_counts[i].func[j].max_loop_2;
		}
	/* print out whitin processor */

	}
  /* print out across processor statistics */
  {
  	extern int do_headers;
  	if( do_headers == 1 )
 		{
  		fprintf( stdout, "# -----------------------------------------------"
    		"------------------------------\n");
  		printf("#    Total     #Calls     #Lines   #Loop1   #Loop2"
			"    #Lops L1 L2 AL    TNEvent  NetEvents\n");
  		fprintf( stdout, "# -----------------------------------------------"
    		"------------------------------\n");
		}
  }

  if( CloneSim_scale_size > 1 )
	my_multiple = CloneSim_scale_size;
  else
	my_multiple = clone_multiple;


  printf("%10d %10d %10d %8d %8d %8d %2d %2d %2d %10d %10d\n",
	totals,
	calls,
	instructions,
	loop_1,
	loop_2,
	loop_1+loop_2,
	max_loop_1,
	max_loop_2,
	my_multiple * (cs_clone_cnt+1),
	TNEvent,
	NetEvents
	);

  {
  	extern int do_headers;
  	if( do_headers == 1 )
 		{
  		fprintf( stdout, "# -----------------------------------------------"
    			"------------------------------\n");
	  	printf("# MFindLP  P_FindLP Clone_t   LP_FWD   LP_CLN   RB_Snd   RB_Rcv  CanPend     ID"
			"\n");
  		fprintf( stdout, "# -----------------------------------------------"
    			"------------------------------\n");
		}
  }
 	printf(" %8d %8d %8d %8d %8d %8d %8d %8d %6d\n",
       	func_counts[CS_MSG_Q_FINDLP].calls,
       	func_counts[CS_PROC_FINDLP].calls,
       	func_counts[CS_SYS_GETCLONE].calls,
       	func_counts[CS_SYS_GETLPFWD].calls,
       	func_counts[CS_SYS_GETLPCLN].calls,
       	func_counts[CS_RBFUNC_SND].calls,
       	func_counts[CS_RBFUNC_RCV].calls,
       	func_counts[CS_CAN_PENDING].calls,
	555555
	);
}



/* ---------------------------------------------------------------------------
** cs_Cntr_ReportResult()
**
** DESCRIPTION: 
**
**---------------------------------------------------------------------------*/
void cs_Cntr_ReportResult( int num_pe )
{
  int i,j;

  int totals=0;
  int calls=0;
  int instructions=0;

  int loop_1=0;
  int loop_2=0;
  int max_loop_1=0;
  int max_loop_2=0;

  int j_loop_1_cnt =0;
  int j_loop_2_cnt =0;

  int j_loop_1_length=0;
  int j_loop_2_length=0;

extern int cs_clone_cnt;
extern int CloneSim_NumClones;
extern int clone_multiple;
extern int CloneSim_scale_size;
int	my_multiple=1;

  if( print_tables[4] == 0 )
  	return;

  for( i = 0; i < num_pe; i++)
	{
  	my_counts[i].my_totals = 0;
  	my_counts[i].calls = 0;
  	my_counts[i].instructions = 0;
  	my_counts[i].loop_1 = 0;
  	my_counts[i].loop_2 = 0;
  	my_counts[i].max_loop_1 = 0;
  	my_counts[i].max_loop_2 = 0;

	for( j = 0; j < CS_MAX_FUNCS; j++ )
		{
		/*
	        * if( my_counts[i].func[j].loop_1 != 0 ) 
		* 	{
		* 	j_loop_1_cnt += 
		* 	j_loop_1_length += 1;
		* 	}
		*/

		/* within processor */
		my_counts[i].my_totals +=  my_counts[i].func[j].calls;
		my_counts[i].my_totals +=  my_counts[i].func[j].instructions;
		my_counts[i].my_totals +=  my_counts[i].func[j].loop_1;
		my_counts[i].my_totals +=  my_counts[i].func[j].loop_2;

		my_counts[i].calls +=  my_counts[i].func[j].calls;
		my_counts[i].instructions +=  my_counts[i].func[j].instructions;
		my_counts[i].loop_1 +=  my_counts[i].func[j].loop_1;
		my_counts[i].loop_2 +=  my_counts[i].func[j].loop_2;

	        if( my_counts[i].max_loop_1 < my_counts[i].func[j].max_loop_1 ) 
		    my_counts[i].max_loop_1 = my_counts[i].func[j].max_loop_1;
	        if( my_counts[i].max_loop_2 < my_counts[i].func[j].max_loop_2 ) 
		    my_counts[i].max_loop_2 = my_counts[i].func[j].max_loop_2;

		/* across processors */
		totals +=  my_counts[i].func[j].calls;
		totals +=  my_counts[i].func[j].instructions;
		totals +=  my_counts[i].func[j].loop_1;
		totals +=  my_counts[i].func[j].loop_2;

		calls +=  my_counts[i].func[j].calls;
		instructions +=  my_counts[i].func[j].instructions;
		loop_1 +=  my_counts[i].func[j].loop_1;
		loop_2 +=  my_counts[i].func[j].loop_2;

	        if( max_loop_1 < my_counts[i].func[j].max_loop_1 ) 
			max_loop_1 = my_counts[i].func[j].max_loop_1;
	        if( max_loop_2 < my_counts[i].func[j].max_loop_2 ) 
			max_loop_2 = my_counts[i].func[j].max_loop_2;
		}
	/* print out whitin processor */

	}
  /* print out across processor statistics */
  fprintf( stdout, "# -----------------------------------------------"
    		"------------------------------\n");
  printf("#    Total     #Calls     #Lines   #Loop1   #Loop2    #Lops XL1 XL2 CLS ACL\n");
  fprintf( stdout, "# -----------------------------------------------"
    		"------------------------------\n");

  if( CloneSim_scale_size > 1 )
	my_multiple = CloneSim_scale_size;
  else
	my_multiple = clone_multiple;


  printf("%10d %10d %10d %8d %8d %8d %3d %3d %3d %3d\n",
	totals,
	calls,
	instructions,
	loop_1,
	loop_2,
	loop_1+loop_2,
	max_loop_1,
	max_loop_2,
	my_multiple * CloneSim_NumClones,
	my_multiple * (cs_clone_cnt+1)
	);
}


/* ---------------------------------------------------------------------------
** cs_CntrSample()
**
** DESCRIPTION: 
**
**---------------------------------------------------------------------------*/
void cs_Cntr_Sample( 
	int num_pe, 
	int func_id, 
	int instructions, 
	int loop_1, 
	int loop_2  
	)
{
  if( print_tables[4] == 0 ) return;
}

