/******************************************************************************
*******************************************************************************
***                                                                         ***
***                       Time Warp Version 2.5                             ***
***         Copyright 1997 by Georgia Institute of Technology               ***
***                         Atlanta, Georgia                                ***
***                                                                         ***
***                      All Rights Reserved                                ***

     Permission to use, copy and modify this software and its
     documentation  for  any research  purpose and  without fee is hereby
     granted, provided that the  above copyright  notice appears in all
     copies and  that both  that  copyright  notice  and  this permission
     notice appear in supporting  documentation.  The use or inclusion of
     this  software  or its documentation in  any  commercial  product or
     distribution of this software to any other party without specific,
     written prior permission is prohibited.

     THE SOFTWARE IS PROVIDED AS IS AND GEORGIA INSTITUTE OF TECHNOLOGY
     DISCLAIMS  ALL  WARRANTIES WITH  REGARD TO THIS SOFTWARE,  INCLUDING
     ALL IMPLIED WARRANTIES  OF  MERCHANTABILITY AND FITNESS.  IN NO EVENT
     SHALL GEORGIA INSTITUTE OF TECHNOLOGY BE LIABLE FOR ANY SPECIAL,
     INDIRECT  OR CONSEQUENTIAL DAMAGES  OR ANY DAMAGES WHATSOEVER
     RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
     CONTRACT, NEGLIGENCE OR OTHER TORTIOUS  ACTION, ARISING OUT OF  OR
     IN  CONNECTION  WITH  THE  USE  OR PERFORMANCE OF THIS SOFTWARE.

***.........................................................................***
*******************************************************************************
******************************************************************************/

#include <gtw_glob.h>

#define CS_MAXPE 		16
#define CS_MAX_FUNCS 		20

#define CS_GET_MSG		0
#define CS_SND_MSG		1

#define CS_MSG_Q_FINDLP 	2
#define CS_MSG_Q_RBFUNC 	3

#define CS_CAN_Q_RBFUNC		4
#define CS_CAN_Q_RBCLRS		5
	
#define CS_PROC_FINDLP		6
#define CS_PROC_ABORT		7
		
#define CS_SYS_GETCLONE		8
#define CS_SYS_GETLPFWD		9
#define CS_SYS_GETLPCLN		10

#define CS_RBFUNC_SND		11
#define CS_RBFUNC_RCV		12
#define CS_CAN_PENDING		13

#define cs_CNTR_SAMPLE(xx_gid,func_id,xx_instructions,xx_loop_1,xx_loop_2)\
  {									\
  extern int print_tables[10];						\
  extern TWLPType TWLP[];						\
  int num_pe=TWLP[xx_gid].Map;						\
  if( print_tables[4] == 1 )						\
	{								\
   	my_counts[num_pe].my_samples    		+= 1;		\
   	my_counts[num_pe].func[func_id].calls   	+= 1;		\
   	my_counts[num_pe].func[func_id].instructions 	+= xx_instructions;\
   	my_counts[num_pe].func[func_id].loop_1 		+= xx_loop_1;	\
   	my_counts[num_pe].func[func_id].loop_2 		+= xx_loop_2;	\
	if( xx_loop_1 > my_counts[num_pe].func[func_id].max_loop_1 )	\
		my_counts[num_pe].func[func_id].max_loop_1 = xx_loop_1;	\
	if( xx_loop_2 > my_counts[num_pe].func[func_id].max_loop_2 )	\
		my_counts[num_pe].func[func_id].max_loop_2 = xx_loop_2;	\
	}								\
  }

typedef struct _counter counter_t;
typedef struct _counter
        {
	/* char *func_char; */
        int calls;
        int instructions;

        int loop_1;
        int loop_2;

        int max_loop_1;
        int max_loop_2;
	} counter_p;

typedef struct _counts counts_t;
typedef struct _counts
        {
	int		my_totals;
        int 		calls;
        int 		instructions;
        int 		loop_1;
        int 		loop_2;
        int 		max_loop_1;
        int 		max_loop_2;

	int		my_samples;
	counter_t  	func[CS_MAX_FUNCS];
        } *count_p;

extern counts_t my_counts[CS_MAXPE];
extern int do_cs_count;
extern void cs_Cntr_Initialize( int num_pe );
extern void cs_Cntr_ReportResult( int num_pe );


