
/******************************************************************************
*******************************************************************************
***                                                                         ***
***                           CLONE-SIM-1.0                                 ***
***                                                                         ***
***         Copyright 1997-2000 by Georgia Institute of Technology          ***
***                          Atlanta, Georgia                               ***
***                                                                         ***
***                        All Rights Reserved                              ***


     Permission   to  use, copy   and   modify   this  software  and  its 
     documentation for any research purpose and without  fee  is   hereby
     granted, provided that the above copyright  notice  appears  in  all
     copies  and  that  both  that  copyright  notice and this permission
     notice  appear in supporting documentation.  The use or inclusion of
     this   software  or  its  documentation in any commercial product or
     distribution of  this  software to any other party without specific,
     written   prior  permission  is prohibited.

     THE SOFTWARE IS PROVIDED  AS  IS AND GEORGIA INSTITUTE OF TECHNOLOGY
     DISCLAIMS  ALL  WARRANTIES WITH  REGARD TO THIS SOFTWARE,  INCLUDING
     ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.  IN  NO EVENT
     SHALL GEORGIA INSTITUTE OF TECHNOLOGY BE  LIABLE  FOR  ANY  SPECIAL,
     INDIRECT  OR  CONSEQUENTIAL  DAMAGES   OR  ANY  DAMAGES   WHATSOEVER
     RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
     CONTRACT, NEGLIGENCE OR OTHER  TORTIOUS  ACTION,  ARISING  OUT OF OR
     IN   CONNECTION  WITH  THE  USE  OR  PERFORMANCE OF  THIS  SOFTWARE.


     ====================================================================
                                                                       
     FILE:      	cs_internal.h 
     INITIAL AUTHOR:    Maria Hybinette                                      

     ====================================================================


***.........................................................................***
*******************************************************************************
******************************************************************************/
#ifndef CLONING_SIM_INTERNAL_H
#define CLONING_SIM_INTERNAL_H

#include	"am_arch.h"
#include	"cs_internal_t.h"

/* ---------------------------------------------------------------------------
** Extern Variables:
**
** DESCRIPTION:
**
**---------------------------------------------------------------------------*/
extern AM_LOCK_TYPE 	cs_clone_cnt_lck;
extern int 		cs_clone_cnt;

extern int            	* cs_IDtoGID;
extern int              * cs_IDtoClone;
extern cs_idmap_t 	* cs_GIDtoID;
extern cs_rmap_t 	* cs_clones;
extern cs_vlpmap_t 	**cs_vlpmapping;

extern int           	cs_deadLPs[CS_MAX_CLONES];
extern int 		CSMsgSize;

extern int		cs_nlp;
extern int		cs_vlp;
extern int		cs_num_clones;
extern int		cs_optimistic;
extern int		cs_do_checkpointing;
extern int              cs_clone_parent;


/* command line  */
extern int 		do_cloning;
extern int 		cs_do_debug;

/* command line  need to REMOVE -> DPAT dependencies */
extern int                       clone_lp;
extern double                    do_preschedule;
extern double                    MITconfigPercent;
extern int                       Sisforked;
extern double                    BAcloning_pt1;
extern double                    do_prune;

/* moving from GTW */
extern double                    CloneSim_CLONETIME[CS_MAX_CLONES];
extern double                    CloneSim_CLONE_RT[CS_MAX_CLONES];
extern int                       CloneSim_NumClones;
extern int 			 CloneSim_setVersions;

extern double 			 CloneSim_CloningPoint;
extern double 			 CloneSim_CloningSpread;

/* ---------------------------------------------------------------------------
** Functions:
**
** DESCRIPTION:
**	functions defined in cs_internal.c
**
**---------------------------------------------------------------------------*/
/* externally accessible */
extern int  CS_SetNumClones( int new_num_clones );
extern int  CS_SetVLPs( int new_vlps );
extern int  CS_SetNLPs( int new_nlps );
extern void CS_GetCommandLine( int argc, char **argv );
extern void CS_InitCloning( void );
extern void CS_CloseCloning( void );
extern int  CS_SimCreate( int uid, double birth_ts );
extern void CS_SimDelete( void );
extern int  CS_MsgPad( int MyMsgSize );
extern void CS_PiggyBackMSG( 
	struct CSMsgData *admn_data, int src, int dst, double tss );
/* new 06-24/99 */
/* MACROS
extern int  CS_GetMsgType( struct MsgData *CSMsg );
extern void CS_SetForwardMsg( struct MsgData *CSMsg, unsigned long int token );
*/

extern int  CS_AssertMsgValidity( struct MsgData *CSMsg, double time_now );
extern int CS_GetLPForward( cs_clone_t vmap, unsigned long int *token );
extern int  CS_GetLPClone( struct MsgData *CSMsg, int *who_is_effected );
extern cs_clone_t CS_GetClone_t( struct MsgData *CSMsg, int gid, 
						int uid, int cloneID );
extern int CS_SetLPClone( cs_clone_t vmap, double birth_time, int active );

/* internal */
extern void cs_InitSynchVariables(void);
extern void cs_CloseSynchVariables(void);
extern void cs_InitCloneTable(void);
extern void cs_AllocateVLPmappingTable(int num_clones, int num_lps);
extern void cs_InitVLPmapping(void);
extern void cs_InitLockUpTables(void);
extern void cs_InitCSMessage(void);
extern int cs_UpdateCloneTable( int parent_cloneID, double birth_ts );
extern void cs_AddCloneToVLPmapping( int parent_uid, int kid_uid, double birth_time, int active );

#endif /* CLONING_SIM_INTERNAL_H */

