/******************************************************************************
*******************************************************************************
***                                                                         ***
***                         INTERACTIVE-SIM-1.0                             ***
***                                                                         ***
***         Copyright 1997-2000 by Georgia Institute of Technology          ***
***                          Atlanta, Georgia                               ***
***                                                                         ***
***                        All Rights Reserved                              ***


     Permission   to  use, copy   and   modify   this  software  and  its 
     documentation for any research purpose and without  fee  is   hereby
     granted, provided that the above copyright  notice  appears  in  all
     copies  and  that  both  that  copyright  notice and this permission
     notice  appear in supporting documentation.  The use or inclusion of
     this   software  or  its  documentation in any commercial product or
     distribution of  this  software to any other party without specific,
     written   prior  permission  is prohibited.

     THE SOFTWARE IS PROVIDED  AS  IS AND GEORGIA INSTITUTE OF TECHNOLOGY
     DISCLAIMS  ALL  WARRANTIES WITH  REGARD TO THIS SOFTWARE,  INCLUDING
     ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.  IN  NO EVENT
     SHALL GEORGIA INSTITUTE OF TECHNOLOGY BE  LIABLE  FOR  ANY  SPECIAL,
     INDIRECT  OR  CONSEQUENTIAL  DAMAGES   OR  ANY  DAMAGES   WHATSOEVER
     RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
     CONTRACT, NEGLIGENCE OR OTHER  TORTIOUS  ACTION,  ARISING  OUT OF OR
     IN   CONNECTION  WITH  THE  USE  OR  PERFORMANCE OF  THIS  SOFTWARE.


     ====================================================================
                                                                       
     FILE:      	is_kernel.c 
     INITIAL AUTHOR:    Maria Hybinette                                      

     ====================================================================

     DESCRIPTION:
	* application layer
	* depends on kernel implementation

	* function calls cannot be called directly by user

***.........................................................................***
*******************************************************************************
******************************************************************************/

#include "is_kernel.h"

is_ui_t 	*is_ui;



/* ---------------------------------------------------------------------------
** IS_AllocateISUI ()
**
** DESCRIPTION: 
**
**---------------------------------------------------------------------------*/
is_ui_t * IS_AllocateISUI( int in_vlp )
{
  is_ui = (is_ui_t *) calloc( in_vlp, sizeof(is_ui_t) ) ;
  return is_ui;
}



/* ---------------------------------------------------------------------------
** IS_InitKernel ()
**
** DESCRIPTION: 
**	called by CS_API
**
**---------------------------------------------------------------------------*/
void IS_InitKernel( void )
{
  char  fn[]="[IS_InitKernel]";

  if ( cs_do_debug > 10 )
  	printf("%s: begin\n", fn );

  IS_SetNumClones(); /* XXX: set in CS_Commandline? */
  IS_SetLPs();		
  IS_AllocateHandlers();	
  IS_SetHandlers();
  IS_SetMsgSize(); 

  if ( cs_do_debug > 10 )
  	printf("%s: done\n", fn );
}


