
/******************************************************************************
*******************************************************************************
***                                                                         ***
***                         INTERACTIVE-SIM-1.0                             ***
***                                                                         ***
***         Copyright 1997-2000 by Georgia Institute of Technology          ***
***                          Atlanta, Georgia                               ***
***                                                                         ***
***                        All Rights Reserved                              ***


     Permission   to  use, copy   and   modify   this  software  and  its 
     documentation for any research purpose and without  fee  is   hereby
     granted, provided that the above copyright  notice  appears  in  all
     copies  and  that  both  that  copyright  notice and this permission
     notice  appear in supporting documentation.  The use or inclusion of
     this   software  or  its  documentation in any commercial product or
     distribution of  this  software to any other party without specific,
     written   prior  permission  is prohibited.

     THE SOFTWARE IS PROVIDED  AS  IS AND GEORGIA INSTITUTE OF TECHNOLOGY
     DISCLAIMS  ALL  WARRANTIES WITH  REGARD TO THIS SOFTWARE,  INCLUDING
     ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.  IN  NO EVENT
     SHALL GEORGIA INSTITUTE OF TECHNOLOGY BE  LIABLE  FOR  ANY  SPECIAL,
     INDIRECT  OR  CONSEQUENTIAL  DAMAGES   OR  ANY  DAMAGES   WHATSOEVER
     RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
     CONTRACT, NEGLIGENCE OR OTHER  TORTIOUS  ACTION,  ARISING  OUT OF OR
     IN   CONNECTION  WITH  THE  USE  OR  PERFORMANCE OF  THIS  SOFTWARE.


     ====================================================================
                                                                       
     FILE:      	is_kernel.h 

     INITIAL AUTHOR:    Maria Hybinette                                      

     ====================================================================


     DESCRIPTION:
	functions called by cs_api_c.


***.........................................................................***
*******************************************************************************
******************************************************************************/
#ifndef IS_KERNEL_H
#define IS_KERNEL_H

#include "is_kernel_t.h"

extern is_ui_t         *is_ui;

/* is_kernel.c */
extern void 	IS_InitKernel( void );
extern is_ui_t *IS_AllocateISUI( int in_vlp );

/* is_gtw.c */
extern void IS_SetLPs ( void );
extern void IS_SetHandlers(void);
extern void IS_AllocateHandlers( void );
extern void IS_SetNumClones( void );
extern void IS_SetMsgSize( void );
extern void IS_SetMsg( int src, int dst );
extern void IS_CopyLPState( int dst, int src );

extern void IS_ISysLP( void *SV, int MyPE );
extern void IS_SysLP( void *SV, void *M, int MyPE );
extern void IS_FSysLP( void * SV, int MyPE );
extern void IS_CloseAppl(void);

#endif /* IS_KERNEL_H */

