/******************************************************************************
*******************************************************************************
***                                                                         ***
***                          INTERACTIVE-SIM-1.0                            ***
***                                                                         ***
***         Copyright 1997-2000 by Georgia Institute of Technology          ***
***                          Atlanta, Georgia                               ***
***                                                                         ***
***                        All Rights Reserved                              ***


     Permission   to  use, copy   and   modify   this  software  and  its 
     documentation for any research purpose and without  fee  is   hereby
     granted, provided that the above copyright  notice  appears  in  all
     copies  and  that  both  that  copyright  notice and this permission
     notice  appear in supporting documentation.  The use or inclusion of
     this   software  or  its  documentation in any commercial product or
     distribution of  this  software to any other party without specific,
     written   prior  permission  is prohibited.

     THE SOFTWARE IS PROVIDED  AS  IS AND GEORGIA INSTITUTE OF TECHNOLOGY
     DISCLAIMS  ALL  WARRANTIES WITH  REGARD TO THIS SOFTWARE,  INCLUDING
     ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.  IN  NO EVENT
     SHALL GEORGIA INSTITUTE OF TECHNOLOGY BE  LIABLE  FOR  ANY  SPECIAL,
     INDIRECT  OR  CONSEQUENTIAL  DAMAGES   OR  ANY  DAMAGES   WHATSOEVER
     RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
     CONTRACT, NEGLIGENCE OR OTHER  TORTIOUS  ACTION,  ARISING  OUT OF OR
     IN   CONNECTION  WITH  THE  USE  OR  PERFORMANCE OF  THIS  SOFTWARE.


     ====================================================================
                                                                       
     FILE:      	is_kernel_t.h 
     INITIAL AUTHOR:    Maria Hybinette                                      

     ====================================================================

     DESCRIPTION:

***.........................................................................***
*******************************************************************************
******************************************************************************/
#ifndef IS_KERNEL_T_H
#define IS_KERNEL_T_H

#include "cs_internal.h"

struct is_ui_s
  {
  int 		Map;
  CSFunc2_p 	CProc;
  CSFunc2_p 	IProc;
  CSFunc_p 	Proc;
  CSFunc2_p 	FProc;

  CSFunc_p 	UpdateProc;

  CSFunc2_p	Monitor;
  double 	monitor_begin;
  double 	monitor_end;
  CSFunc2_p	MonitorAction;

  CSFunc2_p	Sample;
  double	sample_period;
  int		sample_count;
};
typedef struct is_ui_s is_ui_t; 

#endif /* IS_KERNEL_T_H */
