/******************************************************************************
*******************************************************************************
***                                                                         ***
***                       Time Warp Version 2.5                             ***
***         Copyright 1997 by Georgia Institute of Technology               ***
***                         Atlanta, Georgia                                ***
***                                                                         ***
***                      All Rights Reserved                                ***

     Permission to use, copy and modify this software and its
     documentation  for  any research  purpose and  without fee is hereby
     granted, provided that the  above copyright  notice appears in all
     copies and  that both  that  copyright  notice  and  this permission
     notice appear in supporting  documentation.  The use or inclusion of
     this  software  or its documentation in  any  commercial  product or
     distribution of this software to any other party without specific,
     written prior permission is prohibited.

     THE SOFTWARE IS PROVIDED AS IS AND GEORGIA INSTITUTE OF TECHNOLOGY
     DISCLAIMS  ALL  WARRANTIES WITH  REGARD TO THIS SOFTWARE,  INCLUDING
     ALL IMPLIED WARRANTIES  OF  MERCHANTABILITY AND FITNESS.  IN NO EVENT
     SHALL GEORGIA INSTITUTE OF TECHNOLOGY BE LIABLE FOR ANY SPECIAL,
     INDIRECT  OR CONSEQUENTIAL DAMAGES  OR ANY DAMAGES WHATSOEVER
     RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
     CONTRACT, NEGLIGENCE OR OTHER TORTIOUS  ACTION, ARISING OUT OF  OR
     IN  CONNECTION  WITH  THE  USE  OR PERFORMANCE OF THIS SOFTWARE.

***.........................................................................***
*******************************************************************************
******************************************************************************/
#include "gtw.h"
#include <stdio.h>
#include <malloc.h>

/* remember timestamp on last MSZ messages */
#define MSZ 10

#define StateSize 1024

#define MAXLPs 16385 
#define MAXMSGS 25*1024*32

#define NUM_SENDS_TO_SELF 100

/* read only variables in state vector */
struct MyReadOnlyVars 
	{
	int 	MyLP;
	int 	dummy;
	int 	NeighborID; /* ID of neighboring LP */
	};

/* automatically checkpointed variables for LP */
struct MyAutoVars 
	{
	TWSeed 	Seeds;         	/* seeds for random number generator */ 
	int 	Count;         	/* number of messages received */ 
	TWTime 	LastTS[MSZ];	/* remember last MSZ timestamps */

	int 	CloneCount;
        int 	cloned;
   	};

/* incrementally checkpointed variables for LP */
struct MyIncVars 
	{
	TWTime LastTS[MSZ];	/* remember last MSZ timestamps */
	int Count;            	/* number of messages received */
   	};

struct MyLPState 
	{ /* total state for LP using all of above */
   	struct MyReadOnlyVars ROVars;
   	struct MyAutoVars CVars;
   	struct MyIncVars ISVars;
   	};

struct MyMsgData 
   	{ /* Message data */ 
   	int counter;
   	int numself;
	int CloneCount;
  	};

