/******************************************************************************
*******************************************************************************
***                                                                         ***
***                       Time Warp Version 3.0                             ***
***         Copyright 1997 by Georgia Institute of Technology               ***
***                         Atlanta, Georgia                                ***
***                                                                         ***
***                      All Rights Reserved                                ***

     Permission to use, copy and modify this software and its
     documentation  for  any research  purpose and  without fee is hereby
     granted, provided that the  above copyright  notice appears in all
     copies and  that both  that  copyright  notice  and  this permission
     notice appear in supporting  documentation.  The use or inclusion of
     this  software  or its documentation in  any  commercial  product or
     distribution of this software to any other party without specific,
     written prior permission is prohibited.

     THE SOFTWARE IS PROVIDED AS IS AND GEORGIA INSTITUTE OF TECHNOLOGY
     DISCLAIMS  ALL  WARRANTIES WITH  REGARD TO THIS SOFTWARE,  INCLUDING
     ALL IMPLIED WARRANTIES  OF  MERCHANTABILITY AND FITNESS.  IN NO EVENT
     SHALL GEORGIA INSTITUTE OF TECHNOLOGY BE LIABLE FOR ANY SPECIAL,
     INDIRECT  OR CONSEQUENTIAL DAMAGES  OR ANY DAMAGES WHATSOEVER
     RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
     CONTRACT, NEGLIGENCE OR OTHER TORTIOUS  ACTION, ARISING OUT OF  OR
     IN  CONNECTION  WITH  THE  USE  OR PERFORMANCE OF THIS SOFTWARE.

***.........................................................................***
*******************************************************************************
******************************************************************************/

/*****************************************************************************
        TIME WARP kernel on Distributed & Shared Memory Architectures.
******************************************************************************/

#include "gtw.h"
#include <stdio.h>
#include <malloc.h>

/* read only variables in state vector */
struct MyReadOnlyVars {
   int NeighborID; /* ID of neighboring LP */
   };

/* automatically checkpointed variables for LP */
struct MyAutoVars {
   TWSeed Seeds;         /* seeds for random number generator */
   int Count;            /* number of messages received */
   };

/* incrementally checkpointed variables for LP */
struct MyIncVars {
   TWTime LastTS[1000]; /* remember last 1000 timestamps */
   };

struct MyLPState { /* total state for LP using all of above */
   struct MyReadOnlyVars ROVars;
   struct MyAutoVars CVars;
   struct MyIncVars ISVars;
   };

struct MyMsgData {              /* Message data */ 
   int count;
};

struct FinalStruct {              /* Message data */ 
   int count;
};

