#ifndef GTW_IO_H
#define GTW_IO_H
/******************************************************************************
*******************************************************************************
***                                                                         ***
***                       Time Warp Version 2.5                             ***
***         Copyright 1997 by Georgia Institute of Technology               ***
***                         Atlanta, Georgia                                ***
***                                                                         ***
***                      All Rights Reserved                                ***

     Permission to use, copy and modify this software and its
     documentation  for  any research  purpose and  without fee is hereby
     granted, provided that the  above copyright  notice appears in all
     copies and  that both  that  copyright  notice  and  this permission
     notice appear in supporting  documentation.  The use or inclusion of
     this  software  or its documentation in  any  commercial  product or
     distribution of this software to any other party without specific,
     written prior permission is prohibited.

     THE SOFTWARE IS PROVIDED AS IS AND GEORGIA INSTITUTE OF TECHNOLOGY
     DISCLAIMS  ALL  WARRANTIES WITH  REGARD TO THIS SOFTWARE,  INCLUDING
     ALL IMPLIED WARRANTIES  OF  MERCHANTABILITY AND FITNESS.  IN NO EVENT
     SHALL GEORGIA INSTITUTE OF TECHNOLOGY BE LIABLE FOR ANY SPECIAL,
     INDIRECT  OR CONSEQUENTIAL DAMAGES  OR ANY DAMAGES WHATSOEVER
     RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
     CONTRACT, NEGLIGENCE OR OTHER TORTIOUS  ACTION, ARISING OUT OF  OR
     IN  CONNECTION  WITH  THE  USE  OR PERFORMANCE OF THIS SOFTWARE.

***.........................................................................***
*******************************************************************************
******************************************************************************/
#include "gtw_glob.h"
#include "gtw_rand.h"
#define TWBlockingIOSend(io_func_ptr) \
		_TWBlockingIOSend((io_func_ptr), (MyPE));
#define TWNonBlockingIOSend(io_func_ptr) \
		_TWNonBlockingIOSend((io_func_ptr), (MyPE));
#define TWOptimisticIOSend(io_func_ptr, rb_func_ptr) \
		 _TWOptimisticIOSend((io_func_ptr),(rb_func_ptr),(MyPE));

extern int _TWNonBlockingIOSend(IOFuncPtr, int );
extern int _TWBlockingIOSend(IOFuncPtr, int);
extern int _TWOptimisticIOSend(IOFuncPtr, IOFuncPtr, int);

extern int _TWOptimisticProcessing(int, TWTime);
extern int _TWBlockingProcessing(int, TWTime);
extern int _TWNonBlockingProcessing(char, int, TWTime);
extern int _TWProcessing(int);

#endif /* GTW_IO_H */
