#ifndef GTW_IOLIST_H
#define GTW_IOLIST_H
/******************************************************************************
*******************************************************************************
***                                                                         ***
***               Georgia Tech Time Warp Version 2.5                        ***
***         Copyright 1997 by Georgia Institute of Technology               ***
***                         Atlanta, Georgia                                ***
***                                                                         ***
***                      All Rights Reserved                                ***
                                                                       
     Permission to use, copy and modify this software and its
     documentation  for  any research  purpose and  without fee is hereby
     granted, provided that the  above copyright  notice appears in all
     copies and  that both  that  copyright  notice  and  this permission
     notice appear in supporting  documentation.  The use or inclusion of
     this  software  or its documentation in  any  commercial  product or
     distribution of this software to any other party without specific,
     written prior permission is prohibited.

     THE SOFTWARE IS PROVIDED AS IS AND GEORGIA INSTITUTE OF TECHNOLOGY
     DISCLAIMS  ALL  WARRANTIES WITH  REGARD TO THIS SOFTWARE,  INCLUDING
     ALL IMPLIED WARRANTIES  OF  MERCHANTABILITY AND FITNESS.  IN NO EVENT
     SHALL GEORGIA INSTITUTE OF TECHNOLOGY BE LIABLE FOR ANY SPECIAL,
     INDIRECT  OR CONSEQUENTIAL DAMAGES  OR ANY DAMAGES WHATSOEVER
     RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
     CONTRACT, NEGLIGENCE OR OTHER TORTIOUS  ACTION, ARISING OUT OF  OR
     IN  CONNECTION  WITH  THE  USE  OR PERFORMANCE OF THIS SOFTWARE.

***.........................................................................***
*******************************************************************************
******************************************************************************/


/* ---------------------------------------------------------------------------
## PUT_IOLP_E(ev,lp)
##
## DESCRIPTION:  Put an IO event at front at end of LPList.
##
## TYPE:
##  struct Event *ev; int pe 
##---------------------------------------------------------------------------*/

extern void print_iolist(struct Event * ev, char * s);

extern int IO_EvListEnQueue(struct Event * NewEvent, struct LPState *lpstatep);
extern int IO_EvListDeThread(struct Event * DeThread_Event);

extern int IO_NBListEnQueue(struct Event * NewEvent, int pe);
extern int IO_OptListEnQueue(struct Event * NewEvent, int pe);

extern int NB_IO_Delete(struct Event * Delete_Event, 
		int Pe, int DoOldTW, int InEvList);
extern int Opt_IO_Delete(struct Event * Delete_Event, 
		int Pe, int DoOldTW, int InEvList);

extern int IO_NBListDeThread(struct Event * DeThread_Event, int Pe);
extern int IO_OptListDeThread(struct Event * DeThread_Event, int Pe);

extern struct Event * IO_NBListDeQueue(int pe, TWTime GVT);
extern struct Event * IO_OptListDeQueue(int pe, TWTime GVT);

/* --- */

extern int IO_LpListAppend(struct Event * CurEvent, 
		           struct LPState *lpstate_pt);
extern int IOBlockedEnQueue(struct Event *BlockingEvent,
                            struct LPState * lpstate_pt);

extern int IO_LpListDetach(struct Event * first_event, int MyPE);

extern struct Event *  IOBlockedDeQueue(struct Event * ev, int MyPE);

extern int Blocking_EvListDeThread(struct Event * DeThread_Event);

extern int IO_BlockingListDeThread(struct Event * DeThread_Event, int MyPE);

extern int IOBlockedDelete(struct Event * Delete_Event, int MyPE);

extern 	double IOBlockedMinim_Q(int Pe);
#endif /* GTW_IOLIST */
