#####################################################################
# TOP LEVEL MAKEFILE
#####################################################################

# -------------------------------------------------------------------
# depends on environment variables:
# 	o ARCH
#	o PVM_ROOT 
#	o GTW_ROOT
# -------------------------------------------------------------------

# get ARCHFLAGS ARCHLIB and ARCHCPP
include $(GTW_ROOT)/mkfiles/$(ARCH).def

# compiler and pre-processor
CC =  $(ARCHC)
CPP = $(ARCHCPP)

#####################################################################
# DIRECTORIES
#####################################################################
TWKDIR 		= $(GTW_ROOT)/src/gtw

TWMKFILESDIR 	= $(GTW_ROOT)/mkfiles
TWDEPENDDIR 	= $(GTW_ROOT)/mkfiles/$(ARCH)
TWBINDIR  	= $(GTW_ROOT)/bin/$(ARCH)
TWINCLUDEDIR 	= $(GTW_ROOT)/include
TWLIBDIR 	= $(GTW_ROOT)/lib/$(ARCH)
PVMLIBDIR   	= $(PVM_ROOT)/lib/$(ARCH) 

#####################################################################
# INCLUDES
#####################################################################
## TWINCLUDES 	= -I. -I$(TWINCLUDEDIR) -I$(PVM_ROOT)/include
## PVMINCLUDES   	= -I$(PVM_ROOT)/include

TWINCLUDES 	= -I. -I$(TWINCLUDEDIR) 

#####################################################################
# DEFINES 
#####################################################################
#-DCheck -DCheck1 -DCheckIO4
#-Dpower_challenge 
#-DIO2 -DIO3 
# TWDEFINES = -DPMON  -DCheck -DCheck1 -DIO4 -DCheckIO4
# TWDEFINES = -DTiming -DDIST -DSplayTree
# TWDEFINES = -DOLTW -- for use with pvanim
# add -DIO3 for interactive on a single machine (not distributed)
# ARCH is from environment

#TWDEFINES	=  -D$(ARCH) -DSILENT -DIO4 -DNEWTIMER
TWDEFINES	=  -D$(ARCH) -DNEWTIMER

#####################################################################
# FLAGS
#####################################################################
TWDEBUG		= $(ARCHDEBUG)
#TWDEBUG	= -O2
#TWDEBUG		= -g 
TWFLAGS 	= $(TWDEBUG) $(ARCHFLAGS) $(TWDEFINES) $(TWINCLUDES)
CFLAGS 		=  $(TWFLAGS)

#####################################################################
# LIBFLAGS
#####################################################################
#TWLIBS		= -L$(TWLIBDIR) -lTW -lkcomm -lm
#
TWLIBS		= -L$(TWLIBDIR) -lTW -lm

# pvmlib must be declared after twlib
# LIBS 		= $(ARCHLIB) $(TWLIBS) $(PVMLIBS)

LIBS 		= $(ARCHLIB)  $(TWLIBS)

#
# COMMLIBS = $(ARCHLIB) $(TWLIBS) -lTWdis -lkcomm $(PVMLIBS)
#
COMMLIBS = $(ARCHLIB) $(TWLIBS) 

#####################################################################
# RULES -- make sure none of these are `goals'
#####################################################################
.PHONY : clean

$(TWDEPENDDIR)/%.d: %.c
	$(SHELL) -ec '$(CPP) -M \
	$(PVMINCLUDES) $(TWINCLUDES) $(TWDEFINES) $(CPPFLAGS) $< \
	| awk '\''{ print "$(*F).o $(TWLIBDIR)/$(*F).o $(*F).d : " $$2 }'\''\
	 >> $@'
