#ifndef ____PONG________
#define ____PONG________
/******************************************************************************
*******************************************************************************
***                                                                         ***
***                       Time Warp Version 3.0                             ***
***         Copyright 1997 by Georgia Institute of Technology               ***
***                         Atlanta, Georgia                                ***
***                                                                         ***
***                      All Rights Reserved                                ***

     Permission to use, copy and modify this software and its
     documentation  for  any research  purpose and  without fee is hereby
     granted, provided that the  above copyright  notice appears in all
     copies and  that both  that  copyright  notice  and  this permission
     notice appear in supporting  documentation.  The use or inclusion of
     this  software  or its documentation in  any  commercial  product or
     distribution of this software to any other party without specific,
     written prior permission is prohibited.

     THE SOFTWARE IS PROVIDED AS IS AND GEORGIA INSTITUTE OF TECHNOLOGY
     DISCLAIMS  ALL  WARRANTIES WITH  REGARD TO THIS SOFTWARE,  INCLUDING
     ALL IMPLIED WARRANTIES  OF  MERCHANTABILITY AND FITNESS.  IN NO EVENT
     SHALL GEORGIA INSTITUTE OF TECHNOLOGY BE LIABLE FOR ANY SPECIAL,
     INDIRECT  OR CONSEQUENTIAL DAMAGES  OR ANY DAMAGES WHATSOEVER
     RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
     CONTRACT, NEGLIGENCE OR OTHER TORTIOUS  ACTION, ARISING OUT OF  OR
     IN  CONNECTION  WITH  THE  USE  OR PERFORMANCE OF THIS SOFTWARE.

***.........................................................................***
*******************************************************************************
******************************************************************************/

/*****************************************************************************
        TIME WARP kernel on Distributed & Shared Memory Architectures.
******************************************************************************/

#include "gtw.h"
#include <stdio.h>
#include <malloc.h>

int RANGE ;

/* remember timestamp on last MSZ messages */
#define MSZ 10

# define MESSAGE_POPULATION 10 

/* read only variables in state vector */
struct MyReadOnlyVars {
   int NeighborID; /* ID of neighboring LP */
   };

/* automatically checkpointed variables for LP */
struct MyAutoVars {
   TWTime  LastTS[MSZ];    /* remember last MSZ timestamps */
   int var1;           
   int     Count;          /* number of messages received */
   };

struct cacheAutoVars {
   int var1;           
   };

/* incrementally checkpointed variables for LP */
struct MyIncVars {
   TWTime  LastTS[MSZ];    /* remember last MSZ timestamps */
   int var2; 
   int     Count;          /* number of messages received */
   };

struct cacheIncVars {
   int var2; 
   };

struct MyLPState { /* total state for LP using all of above */
   struct MyReadOnlyVars ROVars;
   struct MyAutoVars CVars;
   struct MyIncVars ISVars;
   };

struct cacheLPState { /* total state for LP using all of above */
   struct MyReadOnlyVars ROVars;
   struct cacheAutoVars CVars;
   struct cacheIncVars ISVars;
   };

struct MyMsgData {              /* Message data */ 
   int data1;
   int data2;
};

struct MyStateData
{
	struct cacheLPState st;
	struct MyMsgData msg;
};

struct cacheStruct
{
	struct MyStateData initial ;
	struct MyStateData result ; 
	struct cacheStruct* next ;
};
#endif
