#include <stdio.h>
#include <stdlib.h>

#include "gtw_glob.h"
#include "gtw_debug.h"
#include "gtw_utility.h"
#include "gtw_insim.h"
#include "gtw_ds.h"

/* 
 * one global heap and one heap per PE, need to send in MyPE if parallel
 * heap and 
 *
*/

/* EXTERNS */
extern int NLogArrays;
extern int TW_Incr_Array_Size;

/* GLOBAL */

/* LOCAL */
char * mh_local_mem[D_MAXPROC];

/* forward references */
void * m_calloc( size_t, size_t, int );

/*----------------------------------------------------------------------------
**  mh_init_calloc ()
**
**  DESCRIPTION:
**
**---------------------------------------------------------------------------*/
void mh_init_calloc (int PE)
  {
  char *p;
  int chunks;

  int sum=0;
  int n_alloc =  sizeof(struct log_entry) * TW_Incr_Array_Size;
  n_alloc += sizeof(struct array_ptr);

  sum =  (GState[PE].LPsOnPE)  * (n_alloc * (0 + NLogArrays)) ;

  if (sum < sizeof(TW_LONG))
        sum = sizeof(TW_LONG);
  if ((sum % sizeof(TW_LONG)) != 0)
        sum = ((int) (sum / sizeof(TW_LONG)) + 1) * sizeof(TW_LONG);

  if ((p = (char *) calloc(1,sum)) == NULL)
        {
        printf("WARNING: mh_init_calloc() couldn't allocate memory \n");
        }

  mh_local_mem[PE] = p;
  }


/*----------------------------------------------------------------------------
**  m_estimate ()
**
**  DESCRIPTION:
**
**---------------------------------------------------------------------------*/
int m_estimate(void)
  {
  int sum=0;
  int n_alloc =  sizeof(struct log_entry) * TW_Incr_Array_Size;
  n_alloc += sizeof(struct array_ptr);

  /*
  printf("%d %d %d %d\n", 
	n_alloc,
	sizeof(struct log_entry), 
	TW_Incr_Array_Size, 
	sizeof(struct array_ptr) );
  sum = TWnlp * (n_alloc * (1 + NLogArrays));
  */

  sum = TWnlp * (n_alloc * (0 + NLogArrays));
  return sum;
  }

/*----------------------------------------------------------------------------
**  m_calloc ()
**
**  DESCRIPTION:
**
**---------------------------------------------------------------------------*/
void * m_calloc (size_t nelem, size_t elsize, int MyPE)
  {
  char *first = mh_local_mem[MyPE];
  mh_local_mem[MyPE] = first+(nelem*elsize);
  return ((void *) first);
  }

