#ifdef NEWTIMER
/******************************************************************************
*******************************************************************************
***                                                                         ***
***                       Time Warp Version 3.0                             ***
***         Copyright 1997 by Georgia Institute of Technology               ***
***                         Atlanta, Georgia                                ***
***                                                                         ***
***                      All Rights Reserved                                ***

     Permission to use, copy and modify this software and its
     documentation  for  any research  purpose and  without fee is hereby
     granted, provided that the  above copyright  notice appears in all
     copies and  that both  that  copyright  notice  and  this permission
     notice appear in supporting  documentation.  The use or inclusion of
     this  software  or its documentation in  any  commercial  product or
     distribution of this software to any other party without specific,
     written prior permission is prohibited.

     THE SOFTWARE IS PROVIDED AS IS AND GEORGIA INSTITUTE OF TECHNOLOGY
     DISCLAIMS  ALL  WARRANTIES WITH  REGARD TO THIS SOFTWARE,  INCLUDING
     ALL IMPLIED WARRANTIES  OF  MERCHANTABILITY AND FITNESS.  IN NO EVENT
     SHALL GEORGIA INSTITUTE OF TECHNOLOGY BE LIABLE FOR ANY SPECIAL,
     INDIRECT  OR CONSEQUENTIAL DAMAGES  OR ANY DAMAGES WHATSOEVER
     RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
     CONTRACT, NEGLIGENCE OR OTHER TORTIOUS  ACTION, ARISING OUT OF  OR
     IN  CONNECTION  WITH  THE  USE  OR PERFORMANCE OF THIS SOFTWARE.

***.........................................................................***
*******************************************************************************
******************************************************************************/
#include <unistd.h>
#include <limits.h>

#include "gtw_timing.h"

/***************************************************************************/
/*************************** SGI Timing Support ****************************/
/***************************************************************************/

/* man syssgi */
#if( defined(SGI5) || defined(SGI64) || defined(SGIMP64))

volatile fasttimer_t *fasttimer_addr;
int size_factor;
int pico_sec_per_cycle;
struct timeval tv;

void TWInitTimer( void )
   {
   __psunsigned_t phys_addr, raddr;
   int fd, poffmask;

   poffmask = getpagesize() - 1;
   phys_addr = syssgi(SGI_QUERY_CYCLECNTR, &pico_sec_per_cycle);
   raddr = phys_addr & ~poffmask;
   fd = open("/dev/mmem", O_RDONLY);
   fasttimer_addr = (volatile fasttimer_t *)mmap( 0, poffmask, PROT_READ,
                                                  MAP_PRIVATE, 
                                                  fd, (__psint_t)raddr );
   fasttimer_addr = (fasttimer_t *)((__psunsigned_t)fasttimer_addr + 
                                                    (phys_addr & poffmask));
#ifdef SGI5
   size_factor = 0;
#endif /* SGI5 */

#if( defined(SGI64) || defined(SGIMP64) ) 
   if( syssgi(SGI_CYCLECNTR_SIZE) == 64 )
      size_factor = 1;
   else
      size_factor = 0;
#endif /* SGI64 || SGIMP64 */
   
#ifdef MH_PRINT
   printf("   MAX Timer Resolution ----------> %lf secs\n",
            (double)pico_sec_per_cycle/ 1.0e12 );
   printf("   MAX Time Before Rollover ------> %lf secs \n",
            ((double)UINT_MAX * (double)pico_sec_per_cycle)/ 1.0e12 );
#endif
   }
#endif /* SGI5 || SGI64 || SGIMP64 */

/***************************************************************************/
/*************************** SUN Timing Support ****************************/
/***************************************************************************/

#if( defined(SUN4SOL2) || defined(SUNMP) )

void TWInitTimer()
   {
#ifdef MH_PRINT
   printf("   MAX Timer Resolution ----------> ~%lf secs\n",
            (double)1.0e-9 );
   printf("   MAX Time Before Rollover ------> UNKNOWN \n" );
#endif
   }

#endif /* SUN4SOL2 || SUNMP */

#endif /* NEWTIMER */
